Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
webcam::WebcamManager Interface Reference

The webcam manager interface. More...

`import <WebcamManager.idl;`

## Public Member Functions
vector< Webcam > | getWebcams ()
| Retrieve all connected webcams.
int | getChannel (in Webcam webcam, in string clientType, out Channel channel)
| Returns an existing channel that is currently viewing the given webcam or creates one If the client type is unknown it's added to the list of client types.
vector< Channel > | getChannels ()
| Returns all channels.
int | removeClientType (in string clientType)
| Remove a client type.
vector< string > | getClientTypes ()
| Get all known client types.
map< string, Priority > | getClientTypePriorities ()
| Get the priority of all known client types.
int | setClientTypePriorities (in map< string, Priority > priorities)
| Set the priority of a client type.
map< string, Priority > | getWebcamPriorities ()
| Get the priority of a webcam.
int | setWebcamPriorities (in map< string, Priority > priorities)
| Set the priority of a webcam.

## Public Attributes
constant int | NO_ERROR = 0
| Error codes.
constant int | ERR_INVALID_PARAM = 1
| Invalid parameter for an operation.

## Detailed Description

The webcam manager interface.

Definition at line 44 of file WebcamManager.idl.

## Member Function Documentation

## ◆ getChannel()

int webcam::WebcamManager::getChannel | ( | in Webcam | webcam,
|  | in string | clientType,
|  | out Channel | channel )

Returns an existing channel that is currently viewing the given webcam or creates one If the client type is unknown it's added to the list of client types.

Note: When a new channel is created the priority of the given webcam and channel type is summed up. The result is used to determine the used overall priority.

Parameters

  webcam | webcam
  clientType | the channel client type -> getClientTypes()
  channel | Result: The channel

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM one of the parameters is invalid

## ◆ getChannels()

vector< Channel > webcam::WebcamManager::getChannels | ( |  | ) |

Returns all channels.

Note: you need to release every unneeded channel

Returns
  List of all channels

## ◆ getClientTypePriorities()

map< string, Priority > webcam::WebcamManager::getClientTypePriorities | ( |  | ) |

Get the priority of all known client types.

Returns
  a hash map with the key "event type ID" and the value "priority"

## ◆ getClientTypes()

vector< string > webcam::WebcamManager::getClientTypes | ( |  | ) |

Get all known client types.

Returns
  List of all client types

## ◆ getWebcamPriorities()

map< string, Priority > webcam::WebcamManager::getWebcamPriorities | ( |  | ) |

Get the priority of a webcam.

Returns
  a hash map with the key "webcam ID" and the value "priority"

## ◆ getWebcams()

vector< Webcam > webcam::WebcamManager::getWebcams | ( |  | ) |

Retrieve all connected webcams.

Returns
  List of webcams

## ◆ removeClientType()

int webcam::WebcamManager::removeClientType | ( | in string | clientType | ) |

Remove a client type.

Parameters

  clientType | client type

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM one of the parameters is invalid

## ◆ setClientTypePriorities()

int webcam::WebcamManager::setClientTypePriorities | ( | in map< string, Priority > | priorities | ) |

Set the priority of a client type.

Parameters

  priorities | a hash map with the key "event type ID" and the value "priority"

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM one of the parameters is invalid

## ◆ setWebcamPriorities()

int webcam::WebcamManager::setWebcamPriorities | ( | in map< string, Priority > | priorities | ) |

Set the priority of a webcam.

Parameters

  priorities | a hash map with the key "webcam ID" and the value "priority"

Returns
  NO_ERROR on success
  ERR_INVALID_PARAM one of the parameters is invalid

## Member Data Documentation

## ◆ ERR_INVALID_PARAM

constant int webcam::WebcamManager::ERR_INVALID_PARAM = 1

Invalid parameter for an operation.

Definition at line 50 of file WebcamManager.idl.

## ◆ NO_ERROR

constant int webcam::WebcamManager::NO_ERROR = 0

Error codes.

Operation successful, no error

Definition at line 49 of file WebcamManager.idl.

The documentation for this interface was generated from the following file:

- WebcamManager.idl